#include <ss_oled.h>  //Small Simple OLED Library
#include <Adafruit_NeoPixel.h>

#define SDA_PIN 4
#define SCL_PIN 5
#define LED_PIN 2

#define JOY_UP 0
#define JOY_LT 12
#define JOY_RT 13
//#define JOY_DN NC
//#define JOY_CN NC

#define OLED_WIDTH 128
#define OLED_HEIGHT 64

//#define USE_BACKBUFFER
static uint8_t ucBackBuffer[1024];

SSOLED ssoled;

Adafruit_NeoPixel pixels(1, LED_PIN, NEO_GRB + NEO_KHZ800);

void setup() {
  pinMode(JOY_UP, INPUT_PULLUP);
  pinMode(JOY_LT, INPUT_PULLUP);
  pinMode(JOY_RT, INPUT_PULLUP);
  //pinMode(JOY_DN, INPUT_PULLUP);
  //pinMode(JOY_CN, INPUT_PULLUP);
  
  int rc = oledInit(&ssoled, OLED_128x64, -1, 0, 0, 0, SDA_PIN, SCL_PIN, -1, 400000L); 
  if (rc != OLED_NOT_FOUND)
  {
    char *msgs[] = {(char *)"SSD1306 @ 0x3C", (char *)"SSD1306 @ 0x3D",(char *)"SH1106 @ 0x3C",(char *)"SH1106 @ 0x3D"};
    oledFill(&ssoled, 0, 1);
    oledWriteString(&ssoled, 0, 0, 0, msgs[rc], FONT_NORMAL, 0, 1);
    oledSetBackBuffer(&ssoled, ucBackBuffer);
    delay(2000);
  }
  pixels.begin();
    
  oledFill(&ssoled, 0, 1);
  oled_lines();  
  delay(3000);
  oledFill(&ssoled, 0, 1);
  led_rgb();
  oledFill(&ssoled, 0, 1);
} 

void oled_lines() {
  int x, y;
  for (x=0; x<OLED_WIDTH-1; x+=2)
  {
    oledDrawLine(&ssoled, x, 0, OLED_WIDTH-x, OLED_HEIGHT-1, 1);
  }
  for (y=0; y<OLED_HEIGHT-1; y+=2)
  {
    oledDrawLine(&ssoled, OLED_WIDTH-1,y, 0,OLED_HEIGHT-1-y, 1);
  }
}

void led_rgb(){
  pixels.setPixelColor(0, pixels.Color(150, 0, 0));  //RED
  pixels.show();
  oledWriteString(&ssoled, 0, 0, 0,"RED",FONT_NORMAL, 0, 1);
  delay(1000);

  pixels.setPixelColor(0, pixels.Color(0, 150, 0));  //GREEN
  pixels.show();
  oledWriteString(&ssoled, 0, 0, 0,"GREEN",FONT_NORMAL, 0, 1);
  delay(1000);

  pixels.setPixelColor(0, pixels.Color(0, 0, 150)); //BLUE
  pixels.show(); 
  oledWriteString(&ssoled, 0, 0, 0,"BLUE ",FONT_NORMAL, 0, 1);
  delay(1000);
}

void loop() {
  oledWriteString(&ssoled, 0, 0, 0,"      ",FONT_NORMAL, 0, 1);
  if (!digitalRead(JOY_UP)) {
    oledWriteString(&ssoled, 0, 0, 0,"UP    ",FONT_NORMAL, 0, 1);
  }
  if (!digitalRead(JOY_LT)) {
    oledWriteString(&ssoled, 0, 0, 0,"LEFT  ",FONT_NORMAL, 0, 1);
  }
  if (!digitalRead(JOY_RT)) {
    oledWriteString(&ssoled, 0, 0, 0,"RIGHT  ",FONT_NORMAL, 0, 1);
  }
  /*
  if (!digitalRead(JOY_DN)) {
    oledWriteString(&ssoled, 0, 0, 0,"DOWN  ",FONT_NORMAL, 0, 1);
  }
  if (!digitalRead(JOY_CN)) {
    oledWriteString(&ssoled, 0, 0, 0,"CENTER ",FONT_NORMAL, 0, 1);
  }
  */
  delay(200);  //debounce
}
